/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.mall.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import org.springblade.modules.mall.entity.GoodsSpec;
import org.springblade.modules.mall.vo.GoodsSpecVO;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.List;

/**
 * 商品规格表 服务类
 *
 * @author BladeX
 * @since 2022-05-07
 */
public interface IGoodsSpecService extends IService<GoodsSpec> {


	/**
	 * 根据id获取规格
	 * @param id
	 * @return
	 */
	GoodsSpec get(Serializable id);

	/**
	 * 减少库存
	 * @param goodsSpec
	 * @param num
	 */
	void reduceStock(GoodsSpec goodsSpec, Integer num);

	/**
	 * 增加库存
	 * @param goodsSpecId
	 * @param stock
	 */
	void addStock(Long goodsSpecId, Integer stock);

	/**
	 * 自定义分页
	 *
	 * @param page
	 * @param goodsSpec
	 * @return
	 */
	IPage<GoodsSpecVO> selectGoodsSpecPage(IPage<GoodsSpecVO> page, GoodsSpec goodsSpec);

    void submit(GoodsSpec goodsSpec);

    void deleteByGoodsIds(List<Long> goodsIds);

    List<GoodsSpec> getByGoodsId(Long goodsId);

	void updateStatus(Long id);

	void batchOnSale(List<Long> specIds);

	void batchShelves(List<Long> specIds);

	void batchModifyPrice(List<Long> specIds, BigDecimal salePrice);

	GoodsSpec getLastLowPrice(Long goodsInfoId);
}
